## ros-galactic-class-loader 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(class_loader)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(CLASS_LOADER_IGNORE_AMENT FALSE CACHE BOOL
  "Do not use ament when building this package.")
if(NOT CLASS_LOADER_IGNORE_AMENT)
  find_package(ament_cmake)
  find_package(ament_cmake_ros REQUIRED)
  set(explicit_library_type "")
else()
  set(explicit_library_type "SHARED")
endif()

find_package(console_bridge_vendor REQUIRED) # Provides console_bridge 0.4.0 on platforms without it.
find_package(console_bridge REQUIRED)

find_package(rcpputils REQUIRED)

if(ament_cmake_FOUND)
  ament_export_dependencies(console_bridge)
  ament_export_dependencies(rcpputils)
  ament_export_include_directories(include)
endif()

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
add_library(${PROJECT_NAME} ${explicit_library_type} ${${PROJECT_NAME}_SRCS})
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")

if(ament_cmake_FOUND)
  ament_target_dependencies(${PROJECT_NAME} "console_bridge" "rcpputils")
  ament_export_libraries(${PROJECT_NAME})
  ament_export_targets(${PROJECT_NAME})
else()
  target_include_directories(${PROJECT_NAME}
    PUBLIC ${console_bridge_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} ${console_bridge_LIBRARIES})
endif()
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto QUIET)
  if(ament_lint_auto_FOUND)
    # TODO(mikaelarguedas) add copyright test once the linter accepts /** block comments
    list(APPEND AMENT_LINT_AUTO_EXCLUDE
      ament_cmake_copyright
    )
    ament_lint_auto_find_test_dependencies()

    # Files in test/fviz_case_study do have compatible copyrights
    find_package(ament_cmake_copyright)
    ament_copyright(
      TESTNAME copyright_check_tests_only
      "test/fviz_case_study"
    )
  endif()
  add_subdirectory(test)
endif()

if(ament_cmake_FOUND)
  ament_package(
    CONFIG_EXTRAS "class_loader-extras.cmake"
  )
else()
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS
    ${console_bridge_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library
  # using pkg-config
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/src/${PROJECT_NAME}.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    @ONLY)

  install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc" DESTINATION lib/pkgconfig)
endif()

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME})

install(DIRECTORY include/${PROJECT_NAME}
  DESTINATION include)

=== debian/changelog ===
ros-galactic-class-loader (2.1.2-2focal) focal; urgency=high

  * Remove travis. (#182 <https://github.com/ros/class_loader/issues/182>)
  * Contributors: Chris Lalancette

 -- Michael Carroll <michael@openrobotics.org>  Mon, 12 Apr 2021 07:00:00 -0000

ros-galactic-class-loader (2.1.1-2focal) focal; urgency=high

  * Change index.ros.org -> docs.ros.org. (#181 <https://github.com/ros/class_loader/issues/181>)
  * Contributors: Chris Lalancette

 -- Michael Carroll <michael@openrobotics.org>  Tue, 06 Apr 2021 07:00:00 -0000

ros-galactic-class-loader (2.1.0-2focal) focal; urgency=high

  * Fix ternary null check found by clang static analysis (#176 <https://github.com/ros/class_loader/issues/176>)
  * Update QD to QL 1 (#177 <https://github.com/ros/class_loader/issues/177>)
  * Updated console_bridge QL in QD
  * Update package maintainers. (#169 <https://github.com/ros/class_loader/issues/169>)
  * enable building a static library (#163 <https://github.com/ros/class_loader/issues/163>)
  * Update Quality Declaration to reflect QL 2 (#160 <https://github.com/ros/class_loader/issues/160>).
  * Increase coverage with a graveyard behavior test and unmanaged instance test (#159 <https://github.com/ros/class_loader/issues/159>)
  * Add Security Vulnerability Policy pointing to REP-2006. (#157 <https://github.com/ros/class_loader/issues/157>)
  * Clean up and improve documentation (#156 <https://github.com/ros/class_loader/issues/156>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Dirk Thomas, Michel Hidalgo, Stephen Brawner, ahcorde, brawner

 -- Michael Carroll <michael@openrobotics.org>  Thu, 18 Mar 2021 07:00:00 -0000

ros-galactic-class-loader (2.0.1-2focal) focal; urgency=high

  * Added QD to doxygen related pages (#155 <https://github.com/ros/class_loader/issues/155>)
  * Updated class_loader QD (#152 <https://github.com/ros/class_loader/issues/152>)
  * fix copy and paste error (#154 <https://github.com/ros/class_loader/issues/154>)
  * Fixed warning (#151 <https://github.com/ros/class_loader/issues/151>)
  * Increased code coverage (#141 <https://github.com/ros/class_loader/issues/141>)
  * Added Doxyfile (#148 <https://github.com/ros/class_loader/issues/148>)
  * Added quality declaration draft (#142 <https://github.com/ros/class_loader/issues/142>)
  * Contributors: Alejandro Hernández Cordero, Tully Foote

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 26 May 2020 07:00:00 -0000

ros-galactic-class-loader (2.0.0-2focal) focal; urgency=high

  * Export CMake targets in a addition to include directories / libraries. (#147 <https://github.com/ros/class_loader/issues/147>)
  * Fixed references to poco in error strings. (#144 <https://github.com/ros/class_loader/issues/144>)
  * Removed poco dependency. Shared library management is now provided by rcpputils. (#139 <https://github.com/ros/class_loader/issues/139>)
  * Add missing LICENSE file, matching 3-clause BSD (#137 <https://github.com/ros/class_loader/issues/137>)
  * Code style change: wrap after open parenthesis if not in one line (#138 <https://github.com/ros/class_loader/issues/138>)
  * Fix Travis on macOS. (#135 <https://github.com/ros/class_loader/issues/135>)
  * Use .empty() to check for an empty string. (#132 <https://github.com/ros/class_loader/issues/132>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Dirk Thomas, Jorge Perez

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Sat, 25 Apr 2020 07:00:00 -0000

ros-galactic-class-loader (1.4.0-2focal) focal; urgency=high

  * Fixed setting AbstractMetaObjectBase base class typeid. (#127 <https://github.com/nuclearsandwich/class_loader/issues/127>)
  * Corrected export of class_loader library. (#129 <https://github.com/nuclearsandwich/class_loader/issues/129>)
  * Reduced the number of threads spun up in stress test. (#128 <https://github.com/nuclearsandwich/class_loader/issues/128>)
  * Contributors: Emerson Knapp, Shane Loretz, bpwilcox

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 18 Sep 2019 07:00:00 -0000

ros-galactic-class-loader (1.3.1-2focal) focal; urgency=high

  * Using ament_target_dependencies when possible (#124 <https://github.com/ros/class_loader/issues/124>)
  * Contributors: ivanpauno

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 08 May 2019 07:00:00 -0000

ros-galactic-class-loader (1.3.0-2focal) focal; urgency=high

  * Updated test configuration to check copyright of files where possible. (#123 <https://github.com/ros/class_loader/issues/123>)
  * Updated to use ament_target_dependencies where possible. (#121 <https://github.com/ros/class_loader/issues/121>)
  * Contributors: ivanpauno, jpsamper2009

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Fri, 12 Apr 2019 07:00:00 -0000

ros-galactic-class-loader (1.2.0-2focal) focal; urgency=high

  * Updated maintainer to Steven! Ragnarok the maintainer (#107 <https://github.com/ros/class_loader/issues/107>)
  * Added free impl_ in AbstractMetaObjectBase destructor (#103 <https://github.com/ros/class_loader/issues/103>)
  * Overhauled CI.u (#106 <https://github.com/ros/class_loader/issues/106>)
  * Fixed spacing to comply with uncrusity 0.67 (#99 <https://github.com/ros/class_loader/issues/99>)
  * Updated to use console_bridge_vendor (#98 <https://github.com/ros/class_loader/issues/98>)
  * Contributors: Chris Ye, Mikael Arguedas

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Fri, 16 Nov 2018 08:00:00 -0000

ros-galactic-class-loader (0.3.2-2focal) focal; urgency=high

  * Fixed wrong handling of false statement (pkg-config was not installed)
  * Make catkin optional again
  * Contributors: Esteve Fernandez, Janosch Machowinski, Matthias Goldhoorn

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 22 Apr 2015 07:00:00 -0000

ros-galactic-class-loader (0.3.1-2focal) focal; urgency=high

  * Depend on boost
  * Use FindPoco.cmake from ros/cmake_modules


=== debian/control ===
Source: ros-galactic-class-loader
Section: misc
Priority: optional
Maintainer: Michael Carroll <michael@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libconsole-bridge-dev, ros-galactic-ament-cmake, ros-galactic-ament-cmake-gtest, ros-galactic-ament-cmake-ros, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-common, ros-galactic-console-bridge-vendor, ros-galactic-rcpputils, ros-galactic-ros-workspace
Homepage: http://ros.org/wiki/class_loader
Standards-Version: 3.9.2

Package: ros-galactic-class-loader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libconsole-bridge-dev, ros-galactic-console-bridge-vendor, ros-galactic-rcpputils, ros-galactic-ros-workspace
Description: The class_loader package is a ROS-independent package for loading plugins during runtime and the foundation of the higher level ROS &quot;pluginlib&quot; library.
 class_loader utilizes the host operating system's runtime loader to open runtime libraries (e.g. .so/.dll files), introspect the library for exported plugin classes, and allows users to instantiate objects of these exported classes without the explicit declaration (i.e. header file) for those classes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-class-loader//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
